
#version 460

layout (lines) in;

layout (triangle_strip, max_vertices = 5) out;

uniform mat4 transform;
uniform vec2 lightPosition;

in vec2 originalPos[];

void main() {
	vec4 a = gl_in[0].gl_Position;
	vec4 b = gl_in[1].gl_Position;

	vec2 aInv = originalPos[0];
	vec2 bInv = originalPos[1];

	gl_Position = b;
	EmitVertex();

	gl_Position = a;
	EmitVertex();

	gl_Position = transform * vec4(aInv + (aInv - lightPosition) * 10000, 0, 1);
	EmitVertex();

	gl_Position = transform * vec4(bInv + (bInv - lightPosition) * 10000, 0, 1);
	EmitVertex();

	gl_Position = b;
	EmitVertex();

	EndPrimitive();
}
